from DLOGAtomParser import parser

def rename(args):
    rename_vars = []
    for i in range(len(args)):
        rename_vars.append('x_'+str(i))
    return ','.join(rename_vars)

def var_occurrences(args):
    vars = {}
    for index,arg in enumerate(args):
        if arg[0] == 'var':
            vars[arg[1]] = vars[arg[1]]+[index] if arg[1] in vars else [index]
    var_indices = []
    for key, value in vars.items():
        var_indices.append([key,value])
    return var_indices

def select(args,var_indices):
    constant_conditions = []
    for index,arg in enumerate(args):
        if arg[0] == 'num' or arg[0] == 'str':
            constant_conditions.append('x_'+str(index)+'='+arg[1])
    repeat_conditions = []
    for var in var_indices:
        indices = var[1]
        for i in range(len(indices)-1):
            repeat_conditions.append('x_'+str(indices[i])+'='+'x_'+str(indices[i+1]))
    return " and ".join(constant_conditions + repeat_conditions)

def project(var_indices):
    project_vars = []
    for var in var_indices:
        project_vars.append('x_'+str(var[1][0]))
    return ','.join(project_vars)

def rerename(args,var_indices):
    rerename_vars = []
    for var in var_indices:
        rerename_vars.append(args[var[1][0]][1])
    return ','.join(rerename_vars)

def convert2ra(args,rel_name):
    rename_string = rename(args)
    var_indices = var_occurrences(args)
    select_string = select(args,var_indices)
    project_string = project(var_indices)
    rerename_string = rerename(args,var_indices)
    if select_string == '':
      result = 'rename['+rerename_string+']('+rel_name+')'
    else:
      result = 'rename['+rerename_string+ \
         '](project['+project_string+ \
         '](select['+select_string+ \
         '](rename['+rename_string+ \
         ']('+rel_name+'))))'
    return result

def main():
  while True:
    data = input('\nDLGAtom: ').strip() 
    if data == 'exit':
      break
    try:
      rel_name,args = parser.parse(data)
    except Exception as inst:
      print(inst.args[0])
      continue
    #print(rel_name,args)
    result = convert2ra(args,rel_name)
    print(result)
 
main()
