import ply.lex as lex

tokens = ['COMMA','LPAREN','RPAREN','NAME','STRING','NUMBER']

t_COMMA = r','
t_LPAREN = r'\('
t_RPAREN = r'\)'

def t_NAME(t):
  r'[a-zA-Z][_a-zA-Z0-9]*'
  t.type = 'NAME'
  return t

def t_NUMBER(t):
  r'[0-9]+(\.[0-9]*)?'
  t.type = 'NUMBER'
  return t

def t_STRING(t):
  r'["][^"\n]*["]'
  t.type = 'STRING'
  return t

# Ignored characters
t_ignore = " \r\n\t"
t_ignore_COMMENT = r'\#.*'

def t_error(t):
  print("Illegal character '%s'" % t.value[0])
  raise Exception('LEXER ERROR')

lexer = lex.lex()
## Test it out
#data = '''
#employee(111,"John","Smith",x,y,x,11)
#'''
#
## Give the lexer some input
#lexer.input(data)
#
## Tokenize
#while True:
#    tok = lexer.token()
#    if not tok: 
#        break      # No more input
#    print(tok)
