import ply.lex as lex

tokens = ['COMMA','COLON','LBRACE','RBRACE','LBRACKET','RBRACKET','STRING','NUMBER','SEMI']

t_COMMA = r','
t_SEMI = r';'
t_COLON = r':'
t_LBRACE = r'\{'
t_RBRACE = r'\}'
t_LBRACKET = r'\['
t_RBRACKET = r'\]'

def t_NUMBER(t):
  r'[0-9]+(\.[0-9]*)?'
  t.type = 'NUMBER'
  return t

def t_STRING(t):
  r'["][^"\n]*["]'
  t.type = 'STRING'
  return t

# Ignored characters
t_ignore = " \r\n\t"
t_ignore_COMMENT = r'\#.*'

def t_error(t):
  print("Illegal character '%s'" % t.value[0])
  raise Exception('LEXER ERROR')

lexer = lex.lex()
## Test it out
#data = '''
#{ "name" : "John Smith",
#  "age"  : 25,
#  "address" : { "street" : "123 Main Street",
#                "city" : "Wichita",
#                "state" : "KS",
#                "zip" : 30303
#              }
#}
#'''
#
## Give the lexer some input
#lexer.input(data)
#
## Tokenize
#while True:
#    tok = lexer.token()
#    if not tok: 
#        break      # No more input
#    print(tok)
