object BinaryRelation {

  type BinaryRelation = (Int,Int) => Boolean
  type Element = (Int,Int)
  val bound = 99

  // returns an empty binary relation, i.e. no pairs
  def emptyBinaryRelation: BinaryRelation = ???

  // returns the universal binary relation, i.e. all pairs
  def universalBinaryRelation: BinaryRelation = ???

  // returns true of e is in r, false otherwise
  def contains(r: BinaryRelation, e: Element): Boolean = ???

  // returns true if r1 is a subset of r2, false otherwise
  def subRelation(r1: BinaryRelation, r2: BinaryRelation): Boolean = {
    def helper1(x: Int): Boolean = {
      def helper2(y: Int): Boolean = {
        if (y > bound) true
        else if (contains(r1,(x,y)) && !contains(r2,(x,y))) false
        else helper2(y+1)
      }
      if (x > bound) true
      else if (!helper2(0)) false
      else helper1(x+1)
    }
    helper1(0)
  }
  
  // returns true of r1 equals r2, false otherwise
  def equal(r1: BinaryRelation, r2: BinaryRelation): Boolean = ???

  // returns a new binary relation obtained by adding e to r; if e already
  // is in r then returns r
  def add(r: BinaryRelation, e: Element): BinaryRelation = ???

  // for all a, (a,a) is in r
  def reflexive(r: BinaryRelation): Boolean = ???

  // for all a,b, if (a,b) is in r then (b,a) is also in r
  def symmetric(r: BinaryRelation): Boolean = ???

  // for all a,b,c, if (a,b) is in r and (b,c) is in r then (a,c) is also in r
  def transitive(r: BinaryRelation): Boolean = ???

  // equivalence relation is reflexive, symmetric, and transitive
  def equivalence(r: BinaryRelation): Boolean = ???

  // For all a,b, if a != b and (a,b) in r then (b,a) is not in r
  def antisymmetric(r: BinaryRelation): Boolean = ???

  // returns set union of r1 and r2
  def union(r1: BinaryRelation, r2: BinaryRelation): BinaryRelation = ???

  // returns inverse of r; inverse(r) = { (b,a) | (a,b) in r }
  def inverse(r: BinaryRelation): BinaryRelation = ???

  // look up definition in BinaryRelationNotes.pdf
  def reflexiveClosure(r: BinaryRelation): BinaryRelation = ???

  // look up definition in BinaryRelationNotes.pdf
  def symmetricClosure(r: BinaryRelation): BinaryRelation = ???

  // selfJoin will be useful in implementing transitiveClosure
  // returns a new relation { (a,c) | (a,b) is in r and (b,c) is in r }
  def selfJoin(r: BinaryRelation): BinaryRelation = ???

  // look up definition in BinaryRelationNotes.pdf
  def transitiveClosure(r: BinaryRelation): BinaryRelation = ???

  def toString(r: BinaryRelation): String = {
    val rs = for {
      i < 0 to bound
      j < 0 to bound
      if contains(r, (i, j)) 
    } yield ((i,j))
    rs.mkString("{", ",", "}")
  }

  def printBinaryRelation(r: BinaryRelation): Unit = {
    println(toString(r))
  }

}
